<?php
/**
 * SPDX-FileCopyrightText: 2024 Sascha Nitsch (grumpydeveloper) https://contentnation.net/@grumpydevelop
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @author Sascha Nitsch (grumpydeveloper)
 **/

namespace ScriptedBrowser\Commands;

/**
 * run database query and provide result in variable
 *
 * @param \ScriptedBrowser\Main $main main instance
 * @param \ScriptedBrowser\Control $control control interface
 * @unused-param $control
 * @param array<string,mixed>  $options options
 * @return bool true on success
 */
function dbquery($main, $control, $options)
{
    $dbh = new \Mysqli(
        array_key_exists('hostname', $options) ? $options['hostname'] : '127.0.0.1',
        array_key_exists('username', $options) ? $options['username'] : get_current_user(),
        array_key_exists('password', $options) ? $options['password'] : null,
        $options['database']
    );
    if ($dbh === false) {
        echo "DB connection failed\n";
        return false;
    }

    $sth = $dbh->query($options['query']);
    if ($sth === false) {
        echo "DB query failed\n";
        return false;
    }
    $row = $sth->fetch_array();
    if ($row === false) {
        return false;
    }
    if ($row === false && array_key_exists('result', $options)) {
        echo "DB query returned nothing";
        return false;
    }
    if ($row !== null && array_key_exists('result', $options)) {
        $main->setVar($options['result'], $row[0]);
    }
    $dbh->close();
    return true;
}
